;--------------------------------------------------------------------
; Description:
; This subroutine clears the CPU RAM
; This subroutine can be accessed at any time through a call to 
; JSR LBL.ResetCHRRAM.  No other loading work is necessary.

LBL.ResetCPURAM:
  LDA #$00
  LDX #$00

LBL.ResetCPURAM.Loop:
  STA $0000, x  ; Zero Page
  
  ; $0100 is excluded because it contains the STACK
  ; $0200 is excluded because it contains the SPRITE BUFFER (reset handled elsewhere)
  
  STA $0300, x
  STA $0400, x
  STA $0500, x
  STA $0600, x
  STA $0700, x
  INX
  BNE LBL.ResetCPURAM.Loop

RTS