;----------------------------------------------------------------
; VARIABLES:
;----------------------------------------------------------------

.enum $0000 ; Zero Page Variables

; Buffer for the Palette of the Background
BUF.Palette.Background		.dsb 16

; Buffer for the Palette of the Sprites
BUF.Palette.Sprites			.dsb 16

; Variables that define the controller state
VAR.Controller  			.dsb 4
VAR.Controller.Old 		= VAR.Controller+1
VAR.Controller.Pressed 	= VAR.Controller+2
VAR.Controller.Released = VAR.Controller+3

; Main Loop Jumper Variable
VAR.GameState				.dsb 1

; NMI Flags
FLAG.NMI.RenderingEnabled	.dsb 1
FLAG.NMI.Background.Palette	.dsb 1
FLAG.NMI.Sprites.Palette    .dsb 1
FLAG.NMI.Sprites	     	.dsb 1

; PPU Registers
VAR.PPUCTRL					.dsb 1  ; Register $2000
VAR.PPUMASK					.dsb 1	; Register $2001
VAR.PPUSCROLLX				.dsb 1  ; Register $2005 Write 1
VAR.PPUSCROLLY				.dsb 1  ; Register $2005 Write 2

; Frame Counter
VAR.Frame  				   	.dsb 1

; Pointer that holds the address location in ROM where the nametable data is located.
PTR.Nametable 	            .dsw 1

; Defines which one of the PPU nametable's will be written to (0, 1, 2, 3)
VAR.NametableDestination	.dsb 1

.ende

.enum $0100 ; Program Stack (Required)

.ende

.enum $0200 ; Sprite Buffer (Recommended)

BUF.Sprites 				.dsb 256

.ende

.enum $0300 ; Off Page Variables ($0300-$07FF)

VAR.MenuIndex				.dsb 1

.ende

