;----------------------------------------------------------------
; CHR MEMORY:
;----------------------------------------------------------------

; Background CHR data bank for the Title screen

.base $0000

CHRBANKTITLE = CHRBANKCOUNTER
BANKSIZE = 4
CHRBANKCOUNTER = CHRBANKCOUNTER + BANKSIZE

DAT.TITLE.Background.Tiles:
  incbin "TITLE/TITLE.chr"

.pad $1000

; Background CHR data bank for the Title screen sprites
.base $1000

CHRBANKTITLESPRITES = CHRBANKCOUNTER
BANKSIZE = 1
CHRBANKCOUNTER = CHRBANKCOUNTER + BANKSIZE

DAT.TITLE.Sprites.Tiles:
  incbin "TITLE/TITLE_SPRITES.chr"

.pad $1400

;----------------------------------------------------------------
; PRG MEMORY:
;----------------------------------------------------------------
  
.base $8000

; Nametable
DAT.TITLE.Background.Nametable:
  incbin "TITLE/TITLE.nam"

; Background Palette Data
DAT.TITLE.Background.Palette:
  incbin "TITLE/TITLE.pal"

; Sprite Palette Data
DAT.TITLE.Sprites.Palette:
  incbin "TITLE/TITLE_SPRITES.pal"

; Sprite Intialzation
DAT.TitleScreen.Sprites.Total = 34
DAT.TITLE.Sprites:
  ; Flower
  .db #$B8, #$21, #%00000011, #$5C
  .db #$B8, #$20, #%00000010, #$5C

  ; Rings
  .db #$78, #$00, #%00000000, #$98
  .db #$78, #$01, #%00000000, #$A0
  .db #$78, #$02, #%00000000, #$A8
  .db #$78, #$03, #%00000000, #$B0 
  .db #$80, #$04, #%00000000, #$98
  .db #$80, #$05, #%00000000, #$A0
  .db #$80, #$06, #%00000000, #$A8
  .db #$80, #$07, #%00000000, #$B0
  .db #$88, #$08, #%00000000, #$98
  .db #$88, #$09, #%00000000, #$A0
  .db #$88, #$0A, #%00000000, #$A8
  .db #$88, #$0B, #%00000000, #$B0
  .db #$90, #$0C, #%00000000, #$98
  .db #$90, #$0D, #%00000000, #$A0
  .db #$90, #$0E, #%00000000, #$A8
  .db #$90, #$0F, #%00000000, #$B0 
  .db #$78, #$10, #%00000001, #$C0
  .db #$78, #$11, #%00000001, #$C8
  .db #$78, #$12, #%00000001, #$D0
  .db #$78, #$13, #%00000001, #$D8 
  .db #$80, #$14, #%00000001, #$C0
  .db #$80, #$15, #%00000001, #$C8
  .db #$80, #$16, #%00000001, #$D0
  .db #$80, #$17, #%00000001, #$D8
  .db #$88, #$18, #%00000001, #$C0
  .db #$88, #$19, #%00000001, #$C8
  .db #$88, #$1A, #%00000001, #$D0
  .db #$88, #$1B, #%00000001, #$D8
  .db #$90, #$1C, #%00000001, #$C0
  .db #$90, #$1D, #%00000001, #$C8
  .db #$90, #$1E, #%00000001, #$D0
  .db #$90, #$1F, #%00000001, #$D8

;----------------------------------------------------------------
;  Intialzation Code
;----------------------------------------------------------------  
  
LBL.TITLE.Initialize:
       
  ; Set NMI FLAGS
  LDA FALSE
  STA FLAG.NMI.RenderingEnabled
  STA FLAG.NMI.Background.Palette
  STA FLAG.NMI.Sprites.Palette
  STA FLAG.NMI.Sprites
  
  ; Clear Sprite Buffer
  JSR LBL.ResetSprites

  ;  Intialzation can only start during VBLANK
  ;  This causes the CPU to loop until it the VBLANK has been hit
  - BIT PPUSTATUS
    BPL - 
  
  ; Disable Rendering
  LDX #$00
  STX PPUMASK
  
  ; Swap in CHR Banks
  LDA #$00
  STA BANKSELECT
  LDA #CHRBANKTITLE
  STA BANKDATA
  
  LDA #$01
  STA BANKSELECT
  LDA #(CHRBANKTITLE+2)
  STA BANKDATA
  
  LDA #$02
  STA BANKSELECT
  LDA #CHRBANKTITLESPRITES
  STA BANKDATA
  
  LDA #$03
  STA BANKSELECT
  LDA #CHRBANKTITLESPRITES
  STA BANKDATA
  
  LDA #$04
  STA BANKSELECT
  LDA #CHRBANKTITLESPRITES
  STA BANKDATA
  
  LDA #$05
  STA BANKSELECT
  LDA #CHRBANKTITLESPRITES
  STA BANKDATA

  ; Load Nametable onto PPU
  LDA #$00
  STA VAR.NametableDestination
  LDA #<DAT.TITLE.Background.Nametable
  STA PTR.Nametable
  LDA #>DAT.TITLE.Background.Nametable
  STA PTR.Nametable + 1
  JSR LBL.PPULoadNametable

  ; Load Sprites into buffer
  LDX #$00
  LBL.TITLE.Initialize.Sprites:
    LDA DAT.TITLE.Sprites,X
    STA BUF.Sprites,X
    INX
    CPX #(DAT.TitleScreen.Sprites.Total * 4)
    BNE LBL.TITLE.Initialize.Sprites
	  
  ; Load the Palette Buffer
  LDX #$00
  LBL.TITLE.Initialize.Palettes:
    LDA DAT.TITLE.Background.Palette,X
    STA BUF.Palette.Background,X
    LDA DAT.TITLE.Sprites.Palette,X
    STA BUF.Palette.Sprites,X
    INX
    CPX #$10
    BNE LBL.TITLE.Initialize.Palettes

  ; Set NMI FLAGS
  LDA TRUE
  STA FLAG.NMI.RenderingEnabled
  STA FLAG.NMI.Background.Palette
  STA FLAG.NMI.Sprites.Palette
  STA FLAG.NMI.Sprites
  
  ; Wait for Next NMI
   - BIT $2002
    BPL - 
  
  ; Re-Enable Rendering
  LDA #%00011110
  STA $2001
  
  ; Set Menu Index
  LDA #$00
  STA VAR.MenuIndex	 
  
  LDA #STATE.TITLE.Update
  STA VAR.GameState
  
 RTS 

;----------------------------------------------------------------
;  Update Code
;----------------------------------------------------------------  
 LBL.TITLE.Update:

; Checks the Controller inputs to move the flower

;--------------------------------------------------------------------
; bit:       7     6     5     4     3     2     1     0
; button:    A     B   select start  up   down  left right
;--------------------------------------------------------------------

LDA VAR.Controller.Pressed
AND #%00011100
TAX

LBL.TITLE.Controller.Up:
CPX #%00001000
BNE LBL.TITLE.Controller.Down
  LDA #$00
  STA VAR.MenuIndex
  LDA #$B8
  STA BUF.Sprites
  STA BUF.Sprites + 4
  LDA TRUE
  STA FLAG.NMI.Sprites

LBL.TITLE.Controller.Down:
CPX #%00000100
BNE LBL.TITLE.Controller.Start
  LDA #$01
  STA VAR.MenuIndex
  LDA #$C8
  STA BUF.Sprites
  STA BUF.Sprites + 4
  LDA TRUE
  STA FLAG.NMI.Sprites

LBL.TITLE.Controller.Start:
CPX #%00010000
BNE LBL.TITLE.Controller.Exit
  LDA VAR.MenuIndex
  BNE LBL.TITLE.Controller.Exit
  
	; UPDATE this code to reflect what will happen.  Make sure to include the setting of the PRG Banks
    LDA #STATE.TITLE.Update
    STA VAR.GameState
	
LBL.TITLE.Controller.Exit:
  
RTS
  
.pad  $C000